import { Injectable } from '@nestjs/common';
import { find } from 'geo-tz';
import { TimezoneFinderPort } from '../core/application/ports/timezone-finder.port';
import { zone } from 'timezonecomplete';

@Injectable()
export class TimezoneFinder implements TimezoneFinderPort {
  timezones = (
    lon: number,
    lat: number,
    defaultTimezone?: string,
  ): string[] => {
    const foundTimezones = find(lat, lon);
    if (defaultTimezone && foundTimezones.length == 0) return [defaultTimezone];
    return foundTimezones;
  };

  offset = (timezone: string): number =>
    zone(timezone).offsetForUtc(1970, 1, 1, 0, 0, 0);
}
